﻿using System.Numerics;

namespace TestProject;

/// <summary>
/// 그래픽스 그리기 가능형
/// </summary>
public class GraphicsDrawable : IDrawable
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 그리기 - Draw(canvas, dirtyRectangle)

    /// <summary>
    /// 그리기
    /// </summary>
    /// <param name="canvas">캔버스</param>
    /// <param name="dirtyRectangle">더티 사각형</param>
    public void Draw(ICanvas canvas, RectF dirtyRectangle)
    {
        PathF path = new PathF();

        for(int i = 0; i < 11; i++)
        {
            double angle = 5 * i * 2 * Math.PI / 11;

            PointF point = new PointF(100 * (float)Math.Sin(angle), -100 * (float)Math.Cos(angle));

            if(i == 0)
            {
                path.MoveTo(point);
            }
            else
            {
                path.LineTo(point);
            }
        }

        Matrix3x2 matrix = new Matrix3x2
        (
            1,   // M11, ScaleX
            1,   // M12, ShearY
            0,   // M21, ShearX
            1,   // M22, SacleY
            150, // M31, TranslateX
            150  // M32, TranslateY
        );

        canvas.ConcatenateTransform(matrix);

        canvas.FillColor = Colors.Yellow;

        canvas.FillRectangle(dirtyRectangle);

        canvas.Translate(175, 175);

        canvas.FillColor = Colors.Red;

        canvas.FillPath(path);
    }

    #endregion
}